diff --git a/pyanaconda/ui/gui/spokes/storage.py b/pyanaconda/ui/gui/spokes/storage.py
index 0324ef3..1c6a589 100644
--- a/pyanaconda/ui/gui/spokes/storage.py
+++ b/pyanaconda/ui/gui/spokes/storage.py
@@ -52,6 +52,7 @@ from pyanaconda.ui.gui.utils import enlightbox, gtk_call_once, gtk_thread_wait
 from pyanaconda.kickstart import doKickstartStorage
 from pyanaconda.storage.size import Size
 from pyanaconda.storage.errors import StorageError
+from pyanaconda.storage.platform import platform
 from pyanaconda.threads import threadMgr, AnacondaThread
 from pyanaconda.product import productName
 from pyanaconda.flags import flags
@@ -663,7 +664,7 @@ class StorageSpoke(NormalSpoke, StorageChecker):
         # any of the free space to be useful.
         disk_labels = set([disk.format.labelType for disk in disks \
                                                  if hasattr(disk.format, "labelType")])
-        platform_labels = set(self.storage.platform.diskLabelTypes)
+        platform_labels = set(platform.diskLabelTypes)
         if disk_labels and platform_labels.isdisjoint(disk_labels):
             disk_free = 0
             fs_free = 0
diff --git a/pyanaconda/ui/gui/tools/run-spoke.py b/pyanaconda/ui/gui/tools/run-spoke.py
index 2a16ab8..92173e7 100755
--- a/pyanaconda/ui/gui/tools/run-spoke.py
+++ b/pyanaconda/ui/gui/tools/run-spoke.py
@@ -30,7 +30,6 @@ from pyanaconda.installclass import DefaultInstall
 from pyanaconda.storage import Storage
 from pyanaconda.threads import initThreading
 from pyanaconda.packaging.yumpayload import YumPayload
-from pyanaconda.platform import getPlatform
 from pykickstart.version import makeVersion
 
 # Don't worry with fcoe, iscsi, dasd, any of that crud.
@@ -89,9 +88,8 @@ if not spokeClass:
 
 print "Running %s %s from %s" % (spokeText, spokeClass, spokeModule)
 
-platform = getPlatform()
 ksdata = makeVersion()
-storage = Storage(data=ksdata, platform=platform)
+storage = Storage(data=ksdata)
 storage.reset()
 instclass = DefaultInstall()
 
diff --git a/pyanaconda/ui/tui/tools/run-text-spoke.py b/pyanaconda/ui/tui/tools/run-text-spoke.py
index b542fcb..bc132f8 100755
--- a/pyanaconda/ui/tui/tools/run-text-spoke.py
+++ b/pyanaconda/ui/tui/tools/run-text-spoke.py
@@ -16,7 +16,6 @@ from pyanaconda.installclass import DefaultInstall
 from pyanaconda.storage import Storage
 from pyanaconda.threads import initThreading
 from pyanaconda.packaging.yumpayload import YumPayload
-from pyanaconda.platform import getPlatform
 from pykickstart.version import makeVersion
 from pyanaconda.ui.tui.simpleline import App
 from pyanaconda.ui.tui import YesNoDialog
@@ -79,9 +78,8 @@ if not spokeClass:
 
 print "Running %s %s from %s" % (spokeText, spokeClass, spokeModule)
 
-platform = getPlatform()
 ksdata = makeVersion()
-storage = Storage(data=ksdata, platform=platform)
+storage = Storage(data=ksdata)
 storage.reset()
 instclass = DefaultInstall()
 app = App("TEST HARNESS", yes_or_no_question = YesNoDialog)
diff --git a/tests/kickstart_test/commands_test.py b/tests/kickstart_test/commands_test.py
index 6fce53c..feb7132 100644
--- a/tests/kickstart_test/commands_test.py
+++ b/tests/kickstart_test/commands_test.py
@@ -40,14 +40,14 @@ class CommandVersionTestCase(TestCase):
             'pyanaconda.storage.devicelibs.lvm',
             'pyanaconda.storage.iscsi',
             'pyanaconda.storage.fcoe',
+            'pyanaconda.storage.udev',
             'pyanaconda.storage.zfcp',
             'iutil',
             'constants',
             'flags',
             'anaconda_log',
             'parted',
-            'block',
-            'baseudev'])
+            'block'])
 
         import pyanaconda.anaconda_log
         pyanaconda.anaconda_log.init()
diff --git a/tests/pyanaconda_test/Makefile.am b/tests/pyanaconda_test/Makefile.am
index cd9b189..889d867 100644
--- a/tests/pyanaconda_test/Makefile.am
+++ b/tests/pyanaconda_test/Makefile.am
@@ -25,7 +25,6 @@ ANACDIR = $(top_builddir)/pyanaconda
 TESTS_ENVIRONMENT = PYTHONPATH=$(top_builddir)/tests:$(ANACDIR)/isys/.libs:$(ANACDIR):$(top_builddir)
 
 TESTS = backend_test.py \
-    baseudev_test.py \
     bootloader_test.py \
     cmdline_test.py \
     desktop_test.py \
diff --git a/tests/storage_test/storagetestcase.py b/tests/storage_test/storagetestcase.py
index 4289137..8e5df1d 100644
--- a/tests/storage_test/storagetestcase.py
+++ b/tests/storage_test/storagetestcase.py
@@ -44,7 +44,7 @@ class StorageTestCase(TestCase):
         pyanaconda.iutil.execWithRedirect = Mock()
         pyanaconda.iutil.execWithCapture = Mock()
         pyanaconda.iutil.execWithPulseProgress = Mock()
-        pyanaconda.baseudev = Mock()
+        pyanaconda.storage.udev = Mock()
 
         self.anaconda = Mock()
         self.setUpStorage()
diff --git a/tests/storage_test/tsort_test.py b/tests/storage_test/tsort_test.py
new file mode 100644
index 0000000..cb96997
--- /dev/null
+++ b/tests/storage_test/tsort_test.py
@@ -0,0 +1,62 @@
+
+import unittest
+import pyanaconda.storage.tsort
+
+class TopologicalSortTestCase(unittest.TestCase):
+    def runTest(self):
+        items = [1, 2, 3, 4, 5]
+        edges = [(5, 4), (4, 3), (3, 2), (2, 1)]
+        graph = pyanaconda.storage.tsort.create_graph(items, edges)
+        self._tsortTest(graph)
+
+        edges = [(5, 4), (2, 3), (1, 5)]
+        graph = pyanaconda.storage.tsort.create_graph(items, edges)
+        self._tsortTest(graph)
+
+        edges = [(5, 4), (4, 3), (3, 2), (2, 1), (3, 5)]
+        graph = pyanaconda.storage.tsort.create_graph(items, edges)
+        self.failUnlessRaises(pyanaconda.storage.tsort.CyclicGraphError,
+                              pyanaconda.storage.tsort.tsort,
+                              graph)
+
+        edges = [(5, 4), (4, 3), (3, 2), (2, 1), (2, 3)]
+        graph = pyanaconda.storage.tsort.create_graph(items, edges)
+        self.failUnlessRaises(pyanaconda.storage.tsort.CyclicGraphError,
+                              pyanaconda.storage.tsort.tsort,
+                              graph)
+
+        items = ['a', 'b', 'c', 'd']
+        edges = [('a', 'c'), ('c', 'b')]
+        graph = pyanaconda.storage.tsort.create_graph(items, edges)
+        self._tsortTest(graph)
+
+    def _tsortTest(self, graph):
+        def check_order(order, graph):
+            # since multiple solutions can potentially exist, just verify
+            # that the ordering constraints are satisfied
+            for parent, child in graph['edges']:
+                if order.index(parent) > order.index(child):
+                    return False
+            return True
+
+        try:
+            order = pyanaconda.storage.tsort.tsort(graph)
+        except Exception as e:
+            self.fail(e)
+
+        # verify output list is of the correct length
+        self.failIf(len(order) != len(graph['items']),
+                    "sorted list length is incorrect")
+
+        # verify that all ordering constraints are satisfied
+        self.failUnless(check_order(order, graph),
+                        "ordering constraints not satisfied")
+
+
+def suite():
+    return unittest.TestLoader().loadTestsFromTestCase(TopologicalSortTestCase)
+
+
+if __name__ == "__main__":
+    unittest.main()
+
diff --git a/tests/storage_test/udev_test.py b/tests/storage_test/udev_test.py
new file mode 100644
index 0000000..5d48279
--- /dev/null
+++ b/tests/storage_test/udev_test.py
@@ -0,0 +1,139 @@
+#!/usr/bin/python
+
+import mock
+import os
+
+class UdevTest(mock.TestCase):
+
+    def setUp(self):
+        self.setupModules(["_isys", "block", "ConfigParser"])
+        self.fs = mock.DiskIO()
+
+        import pyanaconda.storage.udev
+        pyanaconda.storage.udev.os = mock.Mock()
+        pyanaconda.storage.udev.log = mock.Mock()
+        pyanaconda.storage.udev.open = self.fs.open
+
+    def tearDown(self):
+        self.tearDownModules()
+
+    def udev_enumerate_devices_test(self):
+        import pyanaconda.storage.udev
+        ENUMERATE_LIST = [
+            '/sys/devices/pci0000:00/0000:00:1f.2/host0/target0:0:0/0:0:0:0/block/sda',
+            '/sys/devices/virtual/block/loop0',
+            '/sys/devices/virtual/block/loop1',
+            '/sys/devices/virtual/block/ram0',
+            '/sys/devices/virtual/block/ram1',
+            '/sys/devices/virtual/block/dm-0',
+        ]
+
+        pyanaconda.storage.udev.global_udev.enumerate_devices = mock.Mock(return_value=ENUMERATE_LIST)
+        ret = pyanaconda.storage.udev.udev_enumerate_devices()
+        self.assertEqual(set(ret),
+            set(['/devices/pci0000:00/0000:00:1f.2/host0/target0:0:0/0:0:0:0/block/sda',
+            '/devices/virtual/block/loop0', '/devices/virtual/block/loop1',
+            '/devices/virtual/block/ram0', '/devices/virtual/block/ram1',
+            '/devices/virtual/block/dm-0'])
+        )
+
+    def udev_get_device_1_test(self):
+        import pyanaconda.storage.udev
+
+        class Device(object):
+            def __init__(self):
+                self.sysname = 'loop1'
+                self.dict = {'symlinks': ['/dev/block/7:1'],
+                    'SUBSYSTEM': 'block',
+                    'MAJOR': '7',
+                    'DEVPATH': '/devices/virtual/block/loop1',
+                    'UDISKS_PRESENTATION_NOPOLICY': '1',
+                    'UDEV_LOG': '3',
+                    'DEVNAME': '/dev/loop1',
+                    'DEVTYPE': 'disk',
+                    'DEVLINKS': '/dev/block/7:1',
+                    'MINOR': '1'
+                }
+
+            def __getitem__(self, key):
+                return self.dict[key]
+
+            def __setitem__(self, key, value):
+                self.dict[key] = value
+
+        pyanaconda.storage.udev.os.path.exists.return_value = True
+        DEV_PATH = '/devices/virtual/block/loop1'
+        dev = Device()
+        pyanaconda.storage.udev.global_udev = mock.Mock()
+        pyanaconda.storage.udev.global_udev.create_device.return_value = dev
+        pyanaconda.storage.udev.udev_parse_uevent_file = mock.Mock(return_value=dev)
+
+        ret = pyanaconda.storage.udev.udev_get_device(DEV_PATH)
+        self.assertTrue(isinstance(ret, Device))
+        self.assertEqual(ret['name'], ret.sysname)
+        self.assertEqual(ret['sysfs_path'], DEV_PATH)
+        self.assertTrue(pyanaconda.storage.udev.udev_parse_uevent_file.called)
+
+    def udev_get_device_2_test(self):
+        import pyanaconda.storage.udev
+        pyanaconda.storage.udev.os.path.exists.return_value = False
+        ret = pyanaconda.storage.udev.udev_get_device('')
+        self.assertEqual(ret, None)
+
+    def udev_get_device_3_test(self):
+        import pyanaconda.storage.udev
+        pyanaconda.storage.udev.os.path.exists.return_value = True
+        pyanaconda.storage.udev.global_udev = mock.Mock()
+        pyanaconda.storage.udev.global_udev.create_device.return_value = None
+        ret = pyanaconda.storage.udev.udev_get_device('')
+        self.assertEqual(ret, None)
+
+    def udev_get_devices_test(self):
+        import pyanaconda.storage.udev
+        pyanaconda.storage.udev.udev_settle = mock.Mock()
+        DEVS = \
+            ['/devices/pci0000:00/0000:00:1f.2/host0/target0:0:0/0:0:0:0/block/sda',
+            '/devices/virtual/block/loop0', '/devices/virtual/block/loop1',
+            '/devices/virtual/block/ram0', '/devices/virtual/block/ram1',
+            '/devices/virtual/block/dm-0']
+        pyanaconda.storage.udev.udev_enumerate_devices = mock.Mock(return_value=DEVS)
+        pyanaconda.storage.udev.udev_get_device = lambda x: x
+        ret = pyanaconda.storage.udev.udev_get_devices()
+        self.assertEqual(ret, DEVS)
+
+    def udev_parse_uevent_file_1_test(self):
+        import pyanaconda.storage.udev
+        pyanaconda.storage.udev.os.path.normpath = os.path.normpath
+        pyanaconda.storage.udev.os.access.return_value = True
+
+        FILE_CONTENT = "MAJOR=7\nMINOR=1\nDEVNAME=loop1\nDEVTYPE=disk\n"
+        self.fs.open('/sys/devices/virtual/block/loop1/uevent', 'w').write(FILE_CONTENT)
+        dev = {'sysfs_path': '/devices/virtual/block/loop1'}
+        ret = pyanaconda.storage.udev.udev_parse_uevent_file(dev)
+        self.assertEqual(ret,
+            {'sysfs_path': '/devices/virtual/block/loop1',
+            'DEVNAME': 'loop1',
+            'DEVTYPE': 'disk',
+            'MAJOR': '7',
+            'MINOR': '1'})
+
+    def udev_parse_uevent_file_2_test(self):
+        import pyanaconda.storage.udev
+        pyanaconda.storage.udev.os.path.normpath = os.path.normpath
+        pyanaconda.storage.udev.os.access.return_value = False
+
+        dev = {'sysfs_path': '/devices/virtual/block/loop1'}
+        ret = pyanaconda.storage.udev.udev_parse_uevent_file(dev)
+        self.assertEqual(ret, {'sysfs_path': '/devices/virtual/block/loop1'})
+
+    def udev_settle_test(self):
+        import pyanaconda.storage.udev
+        pyanaconda.storage.udev.util = mock.Mock()
+        pyanaconda.storage.udev.udev_settle()
+        self.assertTrue(pyanaconda.storage.udev.util.run_program.called)
+
+    def udev_trigger_test(self):
+        import pyanaconda.storage.udev
+        pyanaconda.storage.udev.util = mock.Mock()
+        pyanaconda.storage.udev.udev_trigger()
+        self.assertTrue(pyanaconda.storage.udev.util.run_program.called)
